#define Top_Matrix  1    // 1 - matrix at top, 0 - matrix at bottom

#define Ind_port PORTA  //
#define Ind_tris TRISA  // the registers control port
#define Pin_data F3     //
#define Pin_shift F7    //
#define Pin_write F6    // out registers pinout

#define cannel_ADC RA0    // RA0...RA3

#define Pin_sound PORTB.F7  // the sounder connect pins
#define Dir_sound TRISB.F7  //  and then direction


#define button2_TRIS TRISA.F2 = 1  //
#define button_TRIS TRISA.F4 = 1  // button pins
#define button PORTA.F4 == 0  //
#define button2 PORTA.F2 == 0  // button pins

 // Software I2C connections
sbit Soft_I2C_Scl           at RB1_bit;
sbit Soft_I2C_Sda           at RB2_bit;
sbit Soft_I2C_Scl_Direction at TRISB1_bit;
sbit Soft_I2C_Sda_Direction at TRISB2_bit;
// End Software I2C connections






#define set(x,y)  x = x | (1<<y)         // set bit
#define clear(x,y)  x = x &~(1<<y)       // clear bit
#define int_off  INTCON.GIE = 0
#define int_on  INTCON.GIE = 1



 const char Font[];

// ----------------------------------------------------------------------------
// The table of literal indexes
//
// 0 1 2 3 4 5 6 7 8 9                                                                      .  -  %  !  ?  +
// 0 1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26 27 28 29 30 31 32 33 34 35 36 37 38 39 40 41 42 43 44 45 46 47 48 49
//
//----------------------------------------------------------------------------------------------------------------



const char MenuWorlds[30] = {31,29,30,11,25,44,     // time set
                             22,26,28,28,16,22,     // correction
                             12,31,15,20,23,40,     // alarm clock
                             29,26,12,39,30,44,     // events
                             25,11,29,30,28,44};    // settings

const char Weekday[22] = {13,29,22,27,25,15,13,30,28,29,28,15,35,30,13,27,30,25,29,12,30,48};
                                // su,mo.....sut + last sign '?'

unsigned char VideoRam[40];     // array for VideoRam of matrix
unsigned char TextToInd[24],    // text for running string

              Flags = 0;        // Flags :  F0 - the text allready scroll for time interval
                                //          F1 - 1 s interrupt flag
                                //          F2 - sound on flag
                                //          F3 - set brite 1 - auto, 0 - manual
                                
                                //          F5 ... use to auto-push button (to delay )
                                //          F6 ... 1 - pushjng is in progress
                                //          F7 ... 1 - button is on


char Second, Minute, Hour, Day, Month, Date, Year; // Global date/time variables
char MinuteOld, HourOld;
char EventFlag=0x80;    // flag of exist event today
char Corr_, Corr_1;  // time correction var's
char Duty, Duty_min;  // Duty (brite) and minimal Duty in auto regime
char WaitTime;        // the wait time to enter edited data

volatile char Timer,        // 4ms  timer  (increment in interrupt TMR0)
              TimeCount;      //  1s  timer








 // ============================================================================







//********************* Procedure of pause 2 - 500 ms (by 2ms step) ***********
// In parameter - Delay (ms)
// Needs global variable Timer which increments in 2 ms interrups

void pause_2ms(unsigned char Delay ) {
  Delay += Timer;
  while (Timer != Delay); // wait (Delay)*2 ms
 }

//******************************************************************************










// =============== change the BCD value ========================================
// If isBCD = 1: Parameters are BCD, but really they are hexadecimal,
//               range - 0 - 0x99
// If isBCD = 0: Parameters are HEX-DEC, range - 0 - 255
// =============================================================================
   unsigned char change(char OutVal, char LimLow, char LimHigh, char isBCD) {
    if (OutVal >= LimHigh) OutVal = LimLow;
       else {
          OutVal ++;                        // ++ if HEX
          if (isBCD && ((OutVal & 0x0F) > 9))  // ++ if BCD
                        OutVal += 6;          //
          }
    return OutVal;

  }
// =============================================================================










//********* 10-bit PWM init.+ on  (F = 8000 Hz for Tosc = 8MHz *****************

void init_PWM1(void)  {
 // initialization PWM  at 8000 Hz
 PR2 = 249;
 CCPR1L = 0;
 //CCP1CON =0;
 T2CON = 4;           //  set prescaler = 1 , TMR2 on
 CCP1CON = 0x0C;      // set CCP1 to  PWM mode
 TRISB.RB3 = 0;

 }

//******************************************************************************















// ===================== calling EEPROM_Write with int off =====================
void EEPROM_Write_i(char adr, char x) {
 int_off;
 EEPROM_Write(adr, x);
 while (EECON1.WR);   // wait to write complete
 int_on;
 }
//==============================================================================







// ********** SYNCRONIZATION WITH INTERRUPS By TMR0 ****************************
// *****************************************************************************
void int_sync(void){
  int_off;
  while (INTCON.TMR0IF==0);
  int_on;
 }

//*****************************************************************************









 // ============================================================================
 //  Reads time and date information from RTC (DS1307)
 // ============================================================================

 void read_Time() {
 // int_off;
  int_sync();    // sinhroniztion with interrupts  for correct work
  Soft_I2C_Start();               // Issue start signal
  Soft_I2C_Write(0xD0);           // Address DS1307
  Soft_I2C_Write(0);              // Start from address 0

  int_sync();     // sinhroniztion with interrupts
  Soft_I2C_Start();               // Issue repeated start signal
  Soft_I2C_Write(0xD1);           // Address DS1307 for reading R/W=1

  Second = 0x7F & Soft_I2C_Read(1);     // Read seconds byte  + 7 bit to 0

  int_sync();     // sinhroniztion with interrupts
  Minute = Soft_I2C_Read(1);            // Read minutes byte
  Hour = 0x3F & Soft_I2C_Read(1);       // Read hours byte  + 6,7 bits to 0
  Day = Soft_I2C_Read(1);               // Read weekday byte

  int_sync();     // sinhroniztion with interrupts
  Date = Soft_I2C_Read(1);              // Read date byte
  Month = Soft_I2C_Read(1);             // Read month byte
  Year = Soft_I2C_Read(0);              // Read year byte
  Soft_I2C_Stop();                      // Issue stop signal
 // int_on;
 }

 // ============================================================================









 // ============================================================================
 //  Writes time and date information from RTC (DS1307)
 // ============================================================================

 void write_Time() {
  int_off;
  Soft_I2C_Start();               // Issue start signal
  Soft_I2C_Write(0xD0);           // Address DS1307
  Soft_I2C_Write(0);              // Start from address 0
  Soft_I2C_Write(Second);
  Soft_I2C_Write(Minute);
  Soft_I2C_Write(Hour);
  Soft_I2C_Write(Day);
  Soft_I2C_Write(Date);
  Soft_I2C_Write(Month);
  Soft_I2C_Write(Year);
  Soft_I2C_Stop();               // Issue stop signal
  int_on;
 }

 // ============================================================================




// ============== DS1621 initial ===============================================
void init_DS1621(void){
  int_off;
  Soft_I2C_Start();               // Issue start signal
  Soft_I2C_Write(0x90);           // Address DS1621
  Soft_I2C_Write(0xAC);           // issue config
  Soft_I2C_Write(1);              // one convertion of start
  Soft_I2C_Stop();                // Issue stop signal
  int_on;
 }
// =============================================================================



// =============== Start convertion DS1621 =====================================
void start_DS1621(void) {
  int_off;
  Soft_I2C_Start();               // Issue start signal
  Soft_I2C_Write(0x90);           // Address DS1621
  Soft_I2C_Write(0xEE);           // issue START
  Soft_I2C_Stop();               // Issue stop signal
  int_on;
 }
// =============================================================================



// ================ Test DS1621 to end convertion ==============================
// Returns: 0 - convertion is in progress, 1 - complete
// =============================================================================
char test_DS1621(void) {
  char x;
  int_off;
  Soft_I2C_Start();               // Issue start signal
  Soft_I2C_Write(0x90);           // Address DS1621
  Soft_I2C_Write(0xAC);           // config
  Soft_I2C_Start();               // Issue start signal
  Soft_I2C_Write(0x91);           // Address DS1621   read
  x = Soft_I2C_Read(0);            // read
  Soft_I2C_Stop();                // Issue stop signal
  int_on;
  return x & 0x80;
 }
//==============================================================================



// ================== read temperature =========================================
int read_DS1621(void) {
  unsigned OutValue;
  int_off;
  Soft_I2C_Start();               // Issue start signal
  Soft_I2C_Write(0x90);           // Address DS1621
  Soft_I2C_Write(0xAA);           // Read temp.
  Soft_I2C_Start();               // Issue start signal
  Soft_I2C_Write(0x91);            // read
  OutValue = Soft_I2C_Read(1) << 8;// high byte
  OutValue += Soft_I2C_Read(0);    // low byte
  Soft_I2C_Stop();                // Issue stop signal
  int_on;
  return OutValue;
  
 }

// =============================================================================











// =============== Time running correction =====================================
void timeCorrection(void) {
   char x;
   
   if ((Minute) || (Hour)) return;
   if (Second != 0x19) return;     // corr. at 00:00:19
   
   x = Corr_1 & 0x0F;                                      //  add last fraction
   if ((char)(x + (Corr_& 0x0F)) > 9) Corr_= Corr_+ x + 6; //  and save
       else Corr_ += x;                                    //  fraction of result
    
    Corr_1 = (Corr_1 & 0x80)+(Corr_ & 0x0F); //sign and less then 1s value for next time
    
    Corr_ >>= 4;                          // corr. value
    
    if (Corr_1.F7==0) {
        if (Corr_ ) Second = Second + Corr_ + 6;      // positiv corr.  to 19s
        }
        else if (Corr_ == 10) Second = 0x09;             //
                 else Second -= Corr_;                   // negativ corr.
                 
     write_Time();
     Corr_ = EEPROM_Read(0);
     EEPROM_Write_i(1, Corr_1);            // save sign and fraction
      
      while (Second < 0x20){              // limitless loop protect
        if (Flags.F1 == 1) {
           read_Time();
           Flags.F1 = 0;
         }
       }
 }

// =============================================================================











// ============== buttons: wait antil not pushing ==============================
void buttons_notpushing(void) {

  while ((button2)||(button)); // wait 64 ms after not pushed butt.
  pause_2ms(32);               //
  while ((button2)||(button));
  
  TimeCount = 0;
  }
//==============================================================================









 //******************* testing for >3s or <3s pushed  button *******************
 // Retunes 1 if was pushjng within 3 s and 0 if less
 // ============================================================================

char pushed_3s() {
  TimeCount = 0;
  pause_2ms(32);                 // false switch protect      (64ms)
  while (button){                // wait not pushed
      if (TimeCount >= 6) return 1; // long pushjng
      }
  return 0;                        // short pushing
  }
//******************************************************************************












//************************** button  *******************************************
// In:  Byte to change, low limit, high limit
// Out: changed or not changed byte
// Use increaseble in interrups var. TimeCount

// Flags:                    bit 7 ... 1 - button is on
//                           bit 6 ... 1 - button is in progress
//                           bit 5 ... use to auto-push button (to delay )



// ********** defining of autopush buttons  time (only one uncommented define!)

 //  #define time_auto Timer.F7==0       // 0.5 (sec)
   #define time_auto Timer.F6==0       // 0.25 (sec)
 //  #define time_auto Timer.F5==0       // 0.125 (sec)

 //*****************************************************************************


unsigned char button_push(char OutVal, char LimLow, char LimHigh, char isBCD) {
//char Timer2;

//Timer1 = TimeCount;    // 1 s counter
//Timer2 = Timer;       // 4ms counter

if (Flags.F7==1) {
  if (Flags.F6==0) {                 //
     if (Timer<10)   return OutVal;  // for false switching protect
     Flags.F6 = 1;                   // butt. flag
     if (!(button)) Flags.F7 = 0;    //clear flag if button not pushed
     }
     else {
          if (!(button)) {
              OutVal = change(OutVal, LimLow, LimHigh, isBCD);   //
              Flags &= 0x1F;                                // increment a value
              }
              else {
                if (TimeCount>4) {                               // time 3s to auto
                  if (time_auto) {Flags.F5 = 1; return OutVal;}
                  if (Flags.F5==1) {
                    OutVal = change(OutVal, LimLow, LimHigh, isBCD); // increase
                    Flags.F5 = 0;                             // 1 time in 0.25s
                    }
                  }
                }
           }

  }
if ((Flags.F7==0)&&(button)) {
      TimeCount = 0; Timer = 0; Flags.F7 = 1;
    }                            // clear timer and set flag if  button pushed
if ((Flags.F7==0) && !(button)) TimeCount=0;
                                 // clear Timer after the push
return OutVal;

}


//******************************************************************************






// ================= Clearing the text to run ==================================
void clearText(void) {
   char i;
   for (i=0; i<24; i++) TextToInd[i] = 10;
   }
   
// =============================================================================









 // ===================== Put the sign to indicator ===========================
 // FirstCol - the start colomn of indicator
 // SignNo - The sign index in the Font
 //============================================================================
 
 
 void putSign (char FirstCol, char SignNo) {
      char i, Num = 6;
      if (SignNo > 59) SignNo = 48;  // '?' if out of range
      if (FirstCol > 34) Num = 40 - FirstCol;
      for (i=0; i < Num; i++)
          VideoRam[(char)(FirstCol+i)] = Font[SignNo*6+i];
      }
 //=============================================================================



//=================== Put the text to indicator ================================
// FirstSign - the first sign from TextToInd[]
// FirstByte - the first byte of the first sign
//==============================================================================

void putText (char FirstSign) {
   char i;
   for (i = 0; i<40; i += 6) {
      putSign(i, TextToInd[FirstSign]);
      if (++FirstSign > 23) FirstSign = 0;
      }
  }


//==============================================================================











//============= Makes running text =============================================
// text is scrolling one time in 50 ms 0.3 s per sign)
// withjn (TimeOut) sec and until no pushed button
//==============================================================================
void runText(char TimeOut){
    char Counter, i, j, Sign = 6, Byte = 4;
    putText(0);

    for (j=0; j<=TimeOut; j++) {
      Counter = 20;
      while(1) {
        if (!(--Counter)) break;       // loop within 1 sec
        if (button) return;          // end by pushing button
        
        pause_2ms(25);   // all nexts is doing  1 time per 50 ms

        for (i=0; i<39; VideoRam[i] = VideoRam[++i]);      //  scroll to left

         if (TextToInd[Sign]>59)  TextToInd[Sign] = 48; // '?' if out of range
         VideoRam[39] = Font[6*TextToInd[Sign]+Byte];  // last (new) byte

         Byte++;                            //
         if(Byte > 5) {                     //   next sign and it's byte
           Byte = 0;                        //
           Sign++;                          //
           if (Sign >23) Sign = 0;        //
           }

      }
    }

  }

//==============================================================================












// ======================== inversion area of indicator   ======================
// FirstCol - first colomn to invert
// Num - number of colomns to invert
// =============================================================================
void invert(char FirstCol, char Num){
  unsigned char i;

  Num += FirstCol;
  if (Num > 40)  Num = 40;
  for (i = FirstCol; i < Num; i++)    // inversion
       VideoRam[i] = ~VideoRam[i];      // area

 }

// =============================================================================






// =========== BCD to Text. =====================================================

 void textBCD(char pos1, char bcd) {
    TextToInd[(char)(pos1+1)] = bcd & 0x0F;
    TextToInd[pos1] = bcd >> 4;
   }

//==============================================================================







// ======================= Puts Day to 18 pos. of ind. =========================
void dayToText(char pos) {
   char x, j;
   x = Day + Day + Day;
   if ((x<3)||(x>21)) x=22;    // '?' if out of range
   for (j=pos+2; j>=pos; j--)
       TextToInd[j] = Weekday[--x];

 }
//==============================================================================
 
 
 
 










 // =========== Put to indicator the Date (running) ============================

 //=============================================================================
 void dateToInd() {

   clearText();        // clearing text to run

   textBCD(6, Date);
   TextToInd[8] = 45;
   textBCD(9, Month);
   TextToInd[11] = 45;
   textBCD(12, 0x20);
   textBCD(14, Year);

   dayToText(18);
  }


//==============================================================================







// =========== BCD to ind. =====================================================

 void putBCD(char pos1, char bcd, char Num) {
    putSign(pos1+6, (bcd & 0x0F)+Num);
    putSign(pos1, (bcd >> 4)+Num);
   }
   
//==============================================================================







// ======================== Temperature indication =============================
void tempInd() {
   unsigned int Temp_;
   char i, x;
   
   clearText();
   TextToInd[3] = 30;                //
   TextToInd[4] = 16;                //
   TextToInd[5] = 24;                //
   TextToInd[6] = 27;                //
   TextToInd[7] = 44;                //  TEMP.
 
   for (i=0; i<4; i++) {        // test for ready
      if (test_DS1621()) break;
      pause_2ms(250);       // wait ~0.5 s * 4
      }
      
   Temp_ = read_DS1621();
   
   if ((char)Temp_==0xFF) {
        TextToInd[10] = 48;
        TextToInd[11] = 48;        // "?" if sensor problem
        return;
        }
   x = Temp_ >> 8;
   TextToInd[9] = 49;                    // " + " sign
   if (x.F7 == 1) {
      x = (~x) + 1;
      TextToInd[9] = 45;                 // " - " sign
      }
      
   TextToInd[13] = 0;                          // fraction value
   if ((char)Temp_ )    TextToInd[13] = 5;     //

    i = x/10;

    if (!i) {       // blinking the not significal null
            TextToInd[10]= TextToInd[9];
            TextToInd[9] = 10;
            }
            else  TextToInd[10] = i;

      TextToInd[11] = x%10;
            
   TextToInd[12] = 44;                  // ,
   TextToInd[15] = 46;                  //
   TextToInd[16] = 29;                  //   "C


  }
  
//==============================================================================
  
  
  
  
  
  
  

 //=============================================================================
 //  New time to indicator
 //=============================================================================
 
 void time_to_ind() {
   // int_sync();
    putBCD(28, Second, 50);             //  Font 2
    putBCD(14, Minute, 0);              //
    putBCD(0, Hour, 0);                 // data to ind

    VideoRam[12] = 0x24;              // :
    VideoRam[26] = 0x24;
    VideoRam[13] = 0;
    VideoRam[27] = 0;

  }
  
  //============================================================================













// ============= Changing bcd by button ========================================
// Pos - posision of bcd on ind.
// Bcd - value to change
// LimLow , LimHigh  -  limits of change bcd
// =============================================================================
 char bcd_change_butt(char Pos, char Bcd, char LimLow, char LimHigh) {
 char Bcd1;
 
 Bcd1 = Bcd;
 putBCD(Pos, Bcd, 0);
 invert(Pos, 12);     // inversion
 
 buttons_notpushing();  // wait not bushing button2
 while ((TimeCount <= WaitTime)||(button)||(Flags.F7)) {
    if (button2) break;   // exit if pushed button2
    if (Bcd != Bcd1) {
           putBCD(pos, bcd, 0);
           Bcd1 = Bcd;
          }
    if ((button)||(Flags.F7)) Bcd = button_push(Bcd, LimLow, LimHigh, 1);

   }
 putBCD(Pos, Bcd, 0);   // for out inversion if not changed
 return Bcd;
 }

// =============================================================================













// ===================== Setting the time and Date =============================
// button (long, short) - change value
// wait 8 sec. - next value
//==============================================================================
void timeSet(void){
  char x;
  
  dateToInd();
  putText(6);
  Date = bcd_change_butt(0, Date, 1, 0x31);             // Date set

  Month = bcd_change_butt(18, Month, 1, 0x12);          //

  dateToInd();
  putText(10);
  Year = bcd_change_butt(24, Year, 0, 0x99);              // Year set

  putText(16);
  invert(11,19);
  x=Day;
  buttons_notpushing();  // wait not bushing button2
  while ((TimeCount <= WaitTime)||(button)||(Flags.F7)) {          // wwwkday set loop
       if (button2) break;   // exit if pushed button2
       if (Day != x) {
           dayToText(18);
           x = Day;
           putText(16);
           }
       if ((button)||(Flags.F7)) Day = button_push(Day, 1, 7, 0);

     }



 Time_to_ind();
 Hour = bcd_change_butt(0, Hour, 0, 0x23);             // Hour set

 Time_to_ind();
 Minute = bcd_change_butt(14, Minute, 0, 0x59);        // Minute set
  
 Time_to_ind();
 putBCD(28, 0, 50);     // '00' to second
 invert(28, 12);
 TimeCount = 0;
 Second = 0;
 while (Timecount < 240){       // 120s                // switch on the time
    if (button) break;                                // running with Second = 0
    }
 
 Write_time();
    
 
 }
  
  
//==============================================================================








// ================ Time running correction setting ============================
//  Correction value saves in EEprom at adresses 0 and 1
//==============================================================================
 void timeCorr(void) {
    char x;
   
   Corr_1 &= 0x80;
   
   clearText();                                         //

   TextToInd[2] = 31;                //
   TextToInd[3] = 33;                //
   TextToInd[4] = 26;                //      running text:
   TextToInd[5] = 15;                //
   TextToInd[7] = 19;                //
   TextToInd[8] = 11;                //
   TextToInd[10] = 1;                //       err. time per day
   TextToInd[11] = 0;                //
   TextToInd[13] = 29;                //
   TextToInd[14] = 31;                //
   TextToInd[15] = 30;                //
   TextToInd[16] = 26;                //
   TextToInd[17] = 22;                //

   putText(0);
   buttons_notpushing();  // wait not bushing button2
   runText(10);     // 10s

   clearText();                      //
   TextToInd[4] = 29;                //
   TextToInd[5] = 16;                //   sec
   TextToInd[6] = 22;                //

   TextToInd[0]=45;                          //   sign
   if (Corr_1.F7 == 0) TextToInd[0]=49;     //
   
   putText(0);
   putBCD(6, Corr_, 0);
   invert(6, 12);

   buttons_notpushing();  // wait not bushing button2
   x= Corr_;
   while ((TimeCount <= WaitTime)||(button)||(Flags.F7)) {  // the change corr. loop
       if (button2) break;   // exit if pushed button2
       if (Corr_ != x) {
           putBCD(6, Corr_, 0);
           if (Corr_ == 0) {                       // if zero cross
              Corr_1 ^= 0b10000000;                // invert. bit 7 (sign)
              if (Corr_1.F7 == 0) putSign(0, 49);  //
                  else putSign(0, 45);             // and show the sign
             }
           
           x = Corr_;
         }
       if ((button)||(Flags.F7)) Corr_ = button_push(Corr_, 0, 0x99, 1);
     }
     
    EEPROM_Write_i(0, Corr_); 
    EEPROM_Write_i(1, Corr_1);

 }


//==============================================================================
















 // ============================================================================
 //  Reads time and date information from RTC (DS1307)
 //  AlarmNum - 0...3
 // ============================================================================

 char read_Alarm(char AlarmNum, char ByteNum) {
  char i = 0, OutValue = 0;
  
  if (ByteNum > 8) {i++, ByteNum = 0;}  // will reading all data
  // int_off;
  int_sync();    // sinhroniztion with interrupts  for correct work
  Soft_I2C_Start();               // Issue start signal
  Soft_I2C_Write(0xD0);           // Address DS1307
  Soft_I2C_Write(8+14*AlarmNum+ByteNum);  // Start address

  int_sync();    // sinhroniztion with interrupts  for correct work
  Soft_I2C_Start();               // Issue repeated start signal
  Soft_I2C_Write(0xD1);           // Address DS1307 for reading R/W=1

  if (!i) OutValue = Soft_I2C_Read(0);   // Read one byte
      else {
         int_off;
         for (i=9; i<22; i++)
             TextToInd[i] = Soft_I2C_Read(1); // Read all data
         TextToInd[22] = Soft_I2C_Read(0);   //
        }
           
  Soft_I2C_Stop();                      // Issue stop signal
  int_on;
  return OutValue;
 }

 // ============================================================================









 // ============================================================================
 //  Writes alarmClock information to RTC (DS1307)
 //  AlarmNum - 0...3
 // ============================================================================

 void write_Alarm(char AlarmNum) {
  char i;
  int_off;
  Soft_I2C_Start();                             // Issue start signal
  Soft_I2C_Write(0xD0);                         // Address DS1307
  Soft_I2C_Write(8 + AlarmNum * 14);              // Start address
  for (i=9; i < 23; i++)
      Soft_I2C_Write(TextToInd[i]);
      
  Soft_I2C_Stop();                             // Issue stop signal
  int_on;
 }

 // ============================================================================


















// ============================ Alarm data to ind. =============================
 void alarmToText() {
          textBCD(6, TextToInd[9]);                        // hour
          textBCD(9, TextToInd[10]);                       // Minute
          if (TextToInd[11].F7 == 1) TextToInd[4] = 49;    // '+'
              else  TextToInd[4] = 45;                     // '-'
          TextToInd[11] = 10;
          TextToInd[8] = 47;                               // ':'
   
       }
// =============================================================================








// ================= For switch on-off in settings =============================
// changes the bit_0 of  Value and show '+' or '-' at position  Pos of ind.

char switch_on_off(char Value, char Pos) {
 char x, Sign;
 Sign = 49;                   // '+'
 if (Value.F0==0) Sign = 45;  // '-'
 putSign(Pos, Sign);
 invert(Pos, 6);

 x = Value;
 buttons_notpushing();  // wait not bushing button2
 while (TimeCount <= WaitTime) {
      if (button2) break;   // exit if pushed button2
      if (button) {
           pushed_3s();
           Value ^= 1;             // bit_0 - 0,1,0...
          }
      if(x==Value) continue;
      Sign = 49;                   // '+'
      if (Value.F0==0) Sign = 45;  // '-'
      putSign(Pos, Sign);
      x = Value;
    }
 return Value;
 }
// =============================================================================








// ===================== testing for alerm and processing ======================
void  alarmTest(void) {
 char Day1=1, i, Aday;

 if (Second) return;           // do only if Second = 0
 for (i=1; i<Day; i++)  Day1 <<= 1; // modify Day to bit position
 for (i=0; i<=3; i++){
    if (hour != read_Alarm(i, 0)) continue;
    if (Minute != read_Alarm(i, 1)) continue;
    Aday = read_Alarm(i, 2);
    if ((Aday.F7==0)||((Aday & Day1)==0)) continue;     // test alarms with time
    clearText();
    read_Alarm(i,10);
    alarmToText();
    TextToInd[4]=10;            // delete the sign
    
    Flags.F2 = 1;               // sound on
    runText(60);               // show alarm clock  within 60s
    Flags.F2 = 0; Pin_sound = 1;// sound off

    buttons_notpushing();       // wait not pushed button

   }

 }

// =============================================================================







 // ============================================================================
 //  Reads event information from EEPROM
 //  AlarmNum - 0...13
 // ============================================================================

 char read_Event(char EventNum, char OneByte) {
  char i;
  EventNum = 4+EventNum*18;
  if (OneByte) return EEPROM_Read(EventNum);  // if read one byte
  for (i=6; i<=23; i++)  {
      TextToInd[i] = EEPROM_Read(EventNum++); // Read all data
      }
  }

 // ============================================================================






 // ============================================================================
 //  Reads event information from EEPROM
 //  AlarmNum - 0...13
 // ============================================================================

 void write_Event(char EventNum) {
  char i;
  EventNum = 4+EventNum*18;
  for (i=6; i<=23; i++)  {
      EEPROM_Write_i(EventNum++, TextToInd[i]); // Read all data
      }
  }

 // ============================================================================













// ===================== Edit the text at pos1 to pos2 =========================

 void editText(char pos1, char pos2) {
  char i, Sign, x;
  for (i=pos1; i<=pos2; i++) {
    putText(i-4);
    invert(24,6);
    Sign = 9;
    x = 9;
    buttons_notpushing();  // wait not bushing button2
    while ((TimeCount <= WaitTime)||(button)||(Flags.F7)) {
       if (button2) break;   // exit if pushed button2
       if (Sign != x) {
           TextToInd[i]=Sign; // do if modifyed
           putText(i-4);
           x=Sign;
          }
       if ((button)||(Flags.F7)) Sign = button_push(Sign, 0, 49, 0);

      }

   }
 }
//==============================================================================








//================= read event to text =========================================

void eventToText(char EventNum) {
  read_Event(EventNum, 0);        // read all data
  textBCD(2, TextToInd[6] );          //
  textBCD(5, TextToInd[7]);         //
  TextToInd[4]=44;                 //  xx.xx
  TextToInd[7]=10;
  }
//==============================================================================








// ========================== test Date for event  presents ====================
 void eventTest(void) {
   char i;
   
   if (Minute || Second) return; //exit if time not  xx : 00 : 00
   
   if (Hour == 0x08) {
       for (i=0; i<=13; i++) {
         if (read_Event(i, 1).F7 == 1) continue;    // read one
         read_Event(i, 0);                      // read all
         if ((TextToInd[6] == Date)&&(TextToInd[7] == Month)) EventFlag = i;
         }
       }
   if (EventFlag.F7==0){
   
      eventToText(EventFlag);           // doing carent event
      Flags.F2 = 1;               // sound on
      runText(60);               // running text on
      Flags.F2 = 0; Pin_sound = 0;// sound off

      buttons_notpushing();  // wait not pushed button

      if ((button)||(hour >= 0x20))
           EventFlag = 0x80;       // if event interrupt by button or
                                   // Hour >= 20:00  kill the flag
     }
  }

// =============================================================================












// ======================= Set the events ======================================
// Parameter - the event number

 void eventsSet(char EventNum){
 char x = 0;

 clearText();
 putText(0);
 buttons_notpushing();  // wait not bushing button2

 read_Event(EventNum, 0);
 Date = TextToInd[6];
 Month= TextToInd[7];
 
 TextToInd[1]=13;
 TextToInd[2]=22;
 TextToInd[3]=23;    // on
 TextToInd[6]=10;

 putText(0);

 if (Date.F7==0) x.F0=1;                               //   x= 0 or 1
 x = switch_on_off(x, 30);    // edit the on-off for alarm

 while(1) {
 
    if (x.F0==0) {TextToInd[6].F7 =1; break;}   // exit if not activ
    Date.F7 = 0;
    if (Month > 0x12) {read_Time(); clearText();}  // if uncorrect --> read carent
                                                // end clear text
    textBCD(1, Date);          //
    textBCD(4, Month);         //
    TextToInd[3]=44;           //  xx.xx
    putText(0);
    Date = bcd_change_butt(6, Date, 1, 0x31);     // event date

    Month = bcd_change_butt(24, Month, 1, 0x12); // event month

    editText(8, 23);            // edit text

    TextToInd[6] = Date;
    TextToInd[7] = Month;             //
    break;
   }                                  //
 write_Event(EventNum);               //  save carent events

 }
// =============================================================================









// ======================== Events =============================================
// We have 14 events. Data is saved in EEPROM at adr. 4-21, 22-37,..., 238-255
// Organization: first (0) byte - Date   (if 7-th bit=1 - event is off, =0 - on
//                     (1) byte - Month  ( both in BCD)
//                  (2-17) bytes- Text for ind.
// =============================================================================
 void events(void) {
  char EventNum = 0, EventNum1 = 0xFF;

  clearText();
  putText(0);

  buttons_notpushing();  // wait not pushed button

  TimeCount = 0;
  while (TimeCount < 31) {       // 15s
    
    if (! pushed_3s()) {if(++EventNum > 14) EventNum = 0;} // 0,1,2..14,0...
          else {
               if (EventNum==14) EventNum = EventNum1; // lohg pushing >>
               eventsSet(EventNum);                  // edit carent or new event
               break;
               }

      clearText();
      if (EventNum==14) {
        TextToInd[6]=15;
        TextToInd[7]=26;
        TextToInd[8]=12;
        TextToInd[9]=11;
        TextToInd[10]=13;
        TextToInd[11]=20;
        TextToInd[12]=30;
        TextToInd[13]=40;   // add new
        if (EventNum1.F7==0)  runText(18);   // if free space
        }else
          if (read_Event(EventNum, 1).F7 == 1) {      // read 1 byte
              EventNum1 = EventNum;
              } else {
                  eventToText(EventNum);        // carent event to text
                  runText(18);                  // 18s
                  }

     }



 }
//==============================================================================











 // ======================= Set the alarm clocks ===============================
 // Parameter - the alarm number
 
 void alarmSet(char AlarmNum){
   char x = 0, Ahour, Aminute, Aday;

   clearText();
   putText(0);
   buttons_notpushing();
 
   read_Alarm(AlarmNum, 10);

   Ahour =  TextToInd[9];
   Aminute = TextToInd[10];
   Aday = TextToInd[11];
   alarmToText();              // data to text
   putText(4);

   if (Aday.F7==1) x++;                               //   x= 0 or 1
   x = switch_on_off(x, 0);    // edit the on-off for alarm
   Aday.F7 = 1;
   if (x.F0==0) {
       Aday.F7 =0;
       goto Noedit;
       }

   putText(5);
   Ahour = bcd_change_butt(6, Ahour, 0, 0x23);    // Alarm hours

   Aminute = bcd_change_butt(24, Aminute, 0, 0x59); // Alarm minuts
 
   for (Day=1; Day < 8; Day++) {    // --- Weekday to alarm select ---------------
     TimeCount = 0;
     dayToText(1);
     TextToInd[4]=10;
     TextToInd[6]=10;
     putText(0);
     Aday = switch_on_off(Aday, 5*6);    // edit the on-off for weekday
     x=Aday;
     Aday >>=1;
     if (x.F0 == 1) Aday.F7 = 1;          // round leftscroll
     }
   Aday >>=1;
   if (x.F1 == 1) Aday.F7 = 1;  // ---------------------------------------------

   editText(12, 22);            // edit text
 
Noedit:

   TextToInd[9] = Ahour;
   TextToInd[10] = Aminute;             //
   TextToInd[11] = Aday;                //
                                      //
   write_Alarm(AlarmNum);               //  save carent Alarm

   }
// =============================================================================












// =================== Alarm clock =============================================
// We have 4 alarm clocks. Data is saved in RTC at adr. 8-21, 22-35, 36-49, 50-63
// Organization: first (0) byte - Hours
//                     (1) byte - Minutes  ( both in BCD)
//                     (2) byte - control  (7 bit - on, 0-6 - days to on
//                  (3-13) bytes- Text for ind.
// =============================================================================
 void alarmClock(void) {
    char AlarmNum = 3;

    clearText();
    putText(0);

    buttons_notpushing();  // wait not pushed button
    while (TimeCount < 31) {
    
         if (! pushed_3s()) {if(++AlarmNum > 3) AlarmNum = 0;} // 0,1,2,3,0...
            else {
               alarmSet(AlarmNum);
               break;
               }

          clearText();
          read_Alarm(AlarmNum, 10);                   // text

          alarmToText();                 // data to text
          TextToInd[2] = 44;
          TextToInd[1] = AlarmNum+1;
          runText(18);                  // 18s

      }

 }
//==============================================================================









 
 
 
 
 






// ===================== ADC reading (8 bit) ===================================
char read_ADC(){

  ADCON1 = 0x40;     // ref = Vdd, Tosc/2, left jastify
  ADCON0 = (cannel_ADC << 3); //
  ADCON0.F6 = 1;              //
  ADCON0.ADON = 1;            // cannel, Tosc/8, on
  ADCON0.GO = 1;          // start
  while (ADCON0.GO);      // wait to convertion end

  return ADRESH;     // only hi byte

 }
//==============================================================================







// ================= set Duty in auto regime ===================================
void setDuty () {
  if (Flags.F3 == 1) {  // auto duty
      Duty = read_ADC();
      if (Duty < Duty_min) Duty = Duty_min;
      if (Duty > 247) Duty = 247;
      }
  CCPR1L = ~Duty & 0xFF;        // set pwm duty
 }
//==============================================================================








 
 
 
 
 
 
 
 
 
 
 
 
 




// ====================== editing the Duty (briteness) =========================
// Auto: 0 - Duty, 1 - Duty_min
// =============================================================================
char dutyEdit(char Duty_, char Auto) {
  char x;

  putText(0);
  Duty_ >>= 3;
  x=Duty_+1;    // must not equal
  buttons_notpushing();  // wait not bushing button2
  while ((TimeCount <= WaitTime)||(button)||(Flags.F7)) {          // wait time set loop
       if (button2) break;   // exit if pushed button2
       if (Duty_ != x) {
           Duty = Duty_;
           TextToInd[4] = 11;
           TextToInd[5] = 13;       // auto
           if(Duty_)  {
              TextToInd[4] = Duty_/10;
              TextToInd[5] =  Duty_ % 10;
              Duty <<= 3;
              setDuty();
              }
           putText(0);
           x = Duty_;
            }

       if ((button)||(Flags.F7)) Duty_ = button_push(Duty_, Auto, 31, 0);

     }
  return Duty;
 }
// =============================================================================











// ======================== Settings ===========================================
void settings(void) {
  char x;
  clearText();

  if(Flags.F3==1) Duty = 0; // in auto regime Duty is rundom -> set to 0 manual

  Flags.F3 = 0;  // set manual tuning of briteness

  TextToInd[0] = 43;                //
  TextToInd[1] = 28;                //
  TextToInd[2] = 22;                // briteness
  TextToInd[3] = 44;                //
  
  x = dutyEdit(Duty, 0);
  
  if (!x){                       // doing only if auto
    TextToInd[0] = 24;                //
    TextToInd[1] = 20;                //
    TextToInd[2] = 25;                // MIN

    Duty_min = dutyEdit(Duty_min, 1);
   }
   
  TextToInd[0] = 26;                //
  TextToInd[1] = 18;                //
  TextToInd[2] = 20;                // wait
  TextToInd[3] = 15;                //  butt.
  TextToInd[4] = 44;                //
  putText(0);

  WaitTime >>= 1;
  WaitTime =  bcd_change_butt(28, WaitTime, 5, 8);  // time to enter edit

  Duty = x;
  EEPROM_Write_i(2, Duty + WaitTime - 1);     //
  EEPROM_Write_i(3, Duty_min);                //  save new data
  WaitTime <<= 1;

  if (!Duty) Flags.F3 = 1;    // if 0 set auto briteness

 }
// =============================================================================

















// =========== Date and temperature indication =================================
// Short pushes button changes the ind. time, Date, temper.
// long (>12 s) pushing is activate the menu
//==============================================================================
 void  date_temp(void) {
 static char LongTime=0;
 if (pushed_3s()) {
   LongTime ++;
   if (LongTime > 2) {        // pushed >10 s
     LongTime = 0;
             
     //----------------------------------- MENU --------------------------------
     {       // instad pocedure menu() for stack economy
     char MenuItem = 0, MenuItem_0=1, i, j;
     clearText();
     TextToInd[0] = 45;                //
     TextToInd[1] = 24;                //
     TextToInd[2] = 16;                //
     TextToInd[3] = 25;                //
     TextToInd[4] = 42;                //   -MENU-
     TextToInd[5] = 45;                //
     putText(0);

     buttons_notpushing();  // wait not pushed button
     while (TimeCount <= 30) {        // 15s
       if (MenuItem != MenuItem_0){
           MenuItem_0 = MenuItem;            // if changed
           j = MenuItem*6;
           for (i=0; i<6; i++)
               TextToInd[i] = MenuWorlds[j+i];
           putText(0);                         // show carrent item
           }
       if (button) {
           if (! pushed_3s()) {if(++MenuItem > 4) MenuItem = 0;} // 0,1,2,3,4,0...
              else {
                 switch (MenuItem)  {             // execute menu
                    case 0: timeSet();   break;
                    case 1: timeCorr();  break;
                    case 2: alarmClock(); break;
                    case 3: events();   break;
                    case 4: settings();
                   }
                 break;            // out of while loop
                 }
           }

       }

     }
     //-------------------------------------------------------------------------
     //  end of menu();
 
     buttons_notpushing();  // wait not bushing button2
     return ;
    }
      else return;
  }
  start_DS1621();                // start temp. convertion
  dateToInd();
  runText(23);                      // --> running date  23s

  if (button) {
         pushed_3s();
         tempInd();
         runText(23);                      // --> running date  23s
         }
  pushed_3s();
  LongTime = 0;

}
    
//==============================================================================













 // ============================================================================
 //  Initialization RTC (DS1307)
 // ============================================================================

 void init_DS1307(void) {
   int_off;
   Soft_I2C_Start();               // Issue start signal
   Soft_I2C_Write(0xD0);           // Address DS1307
   Soft_I2C_Write(7);              // Start from address 7
   Soft_I2C_Start();               // Issue repeated start signal
   Soft_I2C_Write(0xD1);           // Address DS1307 for reading R/W=1
   Second = Soft_I2C_Read(0);      // Read control byte
   Soft_I2C_Stop();                //

   if (Second != 0x10){
     TextToInd[12]= 12;
     TextToInd[13]= 31;
     TextToInd[14]= 15;
     TextToInd[15]= 20;
     TextToInd[16]= 23;
     TextToInd[17]= 40;
     TextToInd[18]= 25;
     TextToInd[19]= 20;
     TextToInd[20]= 22;
     TextToInd[21]= 45;
     TextToInd[11]= 0;                         // All alarm clocks are
     TextToInd[10]= 0;                          // init. time 12:00, off
     TextToInd[9]= 0x12;                       // and text same 'Alarm clock - x'
     for (Minute = 0; Minute < 4; Minute++) {
        TextToInd[22]= Minute+1;
        write_Alarm(Minute);
      }
    }


   Soft_I2C_Start();
   Soft_I2C_Write(0xD0);           // Address DS1307
   Soft_I2C_Write(7);              // Start from address 7
   Soft_I2C_Write(0x10);           // DS1307 output to 1 Hz
   Soft_I2C_Stop();                //
   
   int_on;
    
   read_Time();
   write_Time();

  }

 // ============================================================================















// ================== Init. EEprom at first switch on ==========================
// variables in EEProm:  0 - Corr_ ;  1 - Corr_1
//           2 - Duty  and WaitTime (0-2 bits)
//           3 - Duty_min
// =============================================================================
void init_EE(void) {
  if (EEPROM_Read(0) > 0x99){  // the first switching on -- init. EE
  
      EEPROM_Write_i(0, 0);   //
      EEPROM_Write_i(1, 0);   // inicial. time running  corr.
 
      EEPROM_Write_i(2, 0x85); // Duty = 0x80 (middle) - 7..4 bits
                        // time-1 of wait button to enter (6s) - 0..2 bits (4-7)
      EEPROM_Write_i(3, 0x20); // Duty_min = 0x20 (min. duty in auto regime)
     }
  Corr_ = EEPROM_Read(0);
  Corr_1 = EEPROM_Read(1);
  
  Duty =  EEPROM_Read(2);
  WaitTime = ((Duty & 0x07)+1)<<1;  //*2;
  Duty &= 0xF8;
  if (!Duty) Flags.F3 = 1;   // set auto briteness  if Duty = 0
  
  Duty_min = EEPROM_Read(3) & 0xF8;

  
  }

// =============================================================================















 
//==============================================================================
//                          THE MAIN PROCEDURE
//==============================================================================

void main() {

  Ind_tris.Pin_data = 0;                //
  Ind_tris.Pin_shift = 0;               //
  Ind_tris.Pin_write = 0;              // set pinout for registers control
  
  button_TRIS;        //
  button2_TRIS;       // button pins direction
  
  Dir_sound = 0;
  Pin_sound = 1;                    //

  OSCCON = 0b01110010;              // osc - 8 MHz, IntOSC

  CMCON = 7;              // comparators off
  
  ANSEL = 1<<cannel_ADC;  // ADC
  
  OPTION_REG = 0b00000011; // tmr0 prescaler 16 (T = 2 ms), pull_ap on
  INTCON = 0b10110000;     // int_TMR0 on, INTF on

  init_EE();              // init. var's in EEProm
  init_PWM1();

  init_DS1621();            // init. temp. sensor
  init_DS1307();            // init. RTC
  
  read_Time();         //
  time_to_ind();       //
  pause_2ms(250);      // for correct start indicator
  
  while (1) {               //    ---- base loop --------------
     if (Flags.F1 == 1) {
           read_Time();
           time_to_ind();
           timeCorrection();
           alarmTest();
           eventTest();
           Flags.F1 = 0;
          
           setDuty();
        }
     
     if (button)  {
           date_temp();
      }

    }
       
       
 }

//======================= end of MAIN ==========================================







//  *************************  INTERRUPTS  *************************************

void interrupt(){
   if (INTCON.TMR0IF == 1){
      unsigned char To_port=0, Port_pinout, j, i;
      static unsigned char Col_ = 1;      // column of indicator

      if (Col_.F7 == 0)  Col_ <<= 1;       // 00000001, 00000010, ...
         else Col_ = 1;                   // 00000001
         
         
      Port_pinout = Ind_port;
      Port_pinout.Pin_data = 0;
      Port_pinout.Pin_shift = 0;
      Port_pinout.Pin_write = 0;              // set pinout
      
#if Top_Matrix
      for (i=1; i>0; i <<= 1) {                // colomn to reg.

         To_port = Port_pinout;

         if ( Col_ == i) To_port.Pin_data = 1; // 1 to carrent point

         Ind_port = To_port;
         To_port.Pin_shift = 1;
         Ind_port = To_port;         // shift out REG
        }

      i=0;
      do {
        j = i + 8;
        while (j>i) {
         j--;
         To_port = Port_pinout;
         
         if ((VideoRam[j] & Col_) != 0) To_port.Pin_data = 1; // 1 to carrent point
         
         Ind_port = To_port;
         To_port.Pin_shift = 1;
         Ind_port = To_port;         // shift out REG
         }
         i += 8;
        }
        while(i<40);

#endif


#if !Top_Matrix
      for (i=0X80; i>0; i>>=1) {                // colomn to reg.

         To_port = Port_pinout;

         if ( Col_ == i) To_port.Pin_data = 1; // 1 to carrent point

         Ind_port = To_port;
         To_port.Pin_shift = 1;
         Ind_port = To_port;         // shift out REG
        }

      i=40;
      do {
        for (j=i-8; j<i; j++) {
         To_port = Port_pinout;

         if ((VideoRam[j] & Col_) != 0) To_port.Pin_data = 1; // 1 to carrent point

         Ind_port = To_port;
         To_port.Pin_shift = 1;
         Ind_port = To_port;         // shift out REG
         }
         i -= 8;
        }
        while(i);

#endif

        To_port.Pin_write = 1;    //
        Ind_port = To_port;      // write to REG all
        
        Timer += 1;                      //
        if (Timer == 0)  TimeCount += 1; // increment 0.5 sec. timer
        

         if (Flags.F2 == 1) {         // ----------------------------------
             if (TimeCount.F0 == 0) Pin_sound = 0;   // Sound controll
                 else Pin_sound = 1;                 // if sound flag is on
             }

        clear(INTCON,TMR0IF);      // clear flag TMR0IF
    }
  
  
   if (INTCON.INT0IF == 1){
         Flags.F1 = 1;            // set 1s int. flag
         clear(INTCON, INT0IF);
         }

        
 }     //         End of interrupts
 
 //*******************************************************************************